"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bt = require("@babel/types");
function classDisplayNameHandler(documentation, path) {
    if (bt.isClassDeclaration(path.node)) {
        var config = getArgFromDecorator(path.get('decorators'));
        var displayName_1;
        if (config && bt.isObjectExpression(config.node)) {
            config
                .get('properties')
                .filter(function (p) { return bt.isObjectProperty(p.node) && p.node.key.name === 'name'; })
                .forEach(function (p) {
                var valuePath = p.get('value');
                if (bt.isStringLiteral(valuePath.node)) {
                    displayName_1 = valuePath.node.value;
                }
            });
        }
        else {
            displayName_1 = path.node.id ? path.node.id.name : undefined;
        }
        if (displayName_1) {
            documentation.set('displayName', displayName_1);
        }
    }
}
exports.default = classDisplayNameHandler;
function getArgFromDecorator(path) {
    var expForDecorator = path
        .filter(function (p) {
        var exp = p.get('expression');
        var decoratorIdenifier = bt.isCallExpression(exp.node) ? exp.node.callee : exp.node;
        return 'Component' === (bt.isIdentifier(decoratorIdenifier) ? decoratorIdenifier.name : null);
    })[0]
        .get('expression');
    if (bt.isCallExpression(expForDecorator.node)) {
        return expForDecorator.get('arguments', 0);
    }
    return null;
}
//# sourceMappingURL=classDisplayNameHandler.js.map